/* eslint-disable camelcase */
const UserModel = require('../../../models/UserModel')
const jwt = require('jsonwebtoken')

const setGender = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const { gender } = req.body
    if (!gender) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ورودی اشتباه است'
      })
    }
    if (!['male', 'female'].includes(gender)) {
      return res.status(422).json({
        error: true,
        message: 'جنسیت معتبر نیست'
      })
    }
    // جستجوی کاربر با شماره موبایل ارسالی
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const user = await UserModel.findById(decodedToken.id)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }

    // آپدیت نوع یوزر
    user.gender = gender.toLowerCase()
    await user.save()

    return res.json({
      message: 'جنسیت با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}

module.exports = {
  setGender
}
